Index: /ruby/branches/TRY-open_ehr_gem/lib/am/archetype/constraint_model/archetype_constraint.rb
===================================================================
--- /ruby/branches/TRY-open_ehr_gem/lib/am/archetype/constraint_model/archetype_constraint.rb	(revision 317)
+++ /ruby/branches/TRY-open_ehr_gem/lib/am/archetype/constraint_model/archetype_constraint.rb	(revision 318)
@@ -3,5 +3,5 @@
   module AM
     module Archetype
-      module Constraint_Model
+      module ConstraintModel
         class ARCHETYPE_CONSTRAINT
           
Index: /ruby/branches/TRY-open_ehr_gem/lib/am/archetype/constraint_model/primitive.rb
===================================================================
--- /ruby/branches/TRY-open_ehr_gem/lib/am/archetype/constraint_model/primitive.rb	(revision 317)
+++ /ruby/branches/TRY-open_ehr_gem/lib/am/archetype/constraint_model/primitive.rb	(revision 318)
@@ -2,5 +2,5 @@
   module AM
     module Archetype
-      module Constraint_Model
+      module ConstraintModel
 
         module Primitive
@@ -145,5 +145,5 @@
 
         end # of Primitive
-      end # of Constraint_Model
+      end # of ConstraintModel
     end # of Archetype
   end # of AM
Index: /ruby/branches/TRY-open_ehr_gem/lib/open_ehr.rb
===================================================================
--- /ruby/branches/TRY-open_ehr_gem/lib/open_ehr.rb	(revision 317)
+++ /ruby/branches/TRY-open_ehr_gem/lib/open_ehr.rb	(revision 318)
@@ -36,5 +36,5 @@
     module Archetype
       autoload :ARCHETYPE, "am/archetype/archetype.rb"
-      autoload :Constraint_Model, "am/archetype/constraint_model/archetype_constraint.rb"
+#      autoload :ConstraintModel, "am/archetype/constraint_model/archetype_constraint.rb"
       autoload :Ontology, "am/archetype/ontology.rb"
 
@@ -43,6 +43,8 @@
       end
 
-      module Constraint_Model
+      module ConstraintModel
         autoload :ARCHETYPE_CONSTRAINT, "am/archetype/constraint_model/archetype_constraint.rb"
+        autoload :CARDINALITY, "am/archetype/constraint_model/archetype_constraint.rb"
+        autoload :C_SINGLE_ATTRIBUTE, "am/archetype/constraint_model/archetype_constraint.rb"
         autoload :ARCHETYPE_SLOT, "am/archetype/constraint_model/archetype_constraint.rb"
         autoload :Primitive, "am/archetype/constraint_model/primitive.rb"
Index: /ruby/trunk/lib/adl_parser/lib/adl_scanner.rb
===================================================================
--- /ruby/trunk/lib/adl_parser/lib/adl_scanner.rb	(revision 317)
+++ /ruby/trunk/lib/adl_parser/lib/adl_scanner.rb	(revision 318)
@@ -276,4 +276,6 @@
                 @@logger.debug("DADLScanner#scan: COMMENT = #{$&} at #{@filename}:#{@lineno}")
                 ;
+              when /\A[a-z]+:\/\/[^<>|\\{}^~"\[\] ]*/ #V_URI
+                yield :V_URI, $&
               when /\A[a-z][a-zA-Z0-9_]*/
                 word = $&.dup
@@ -316,11 +318,4 @@
                       yield :SYM_END_DBLOCK, :SYM_END_DBLOCK
                     end
-#                     adl_type = @adl_type.pop
-#                     if adl_type == :dadl
-#                       yield :SYM_END_DBLOCK, :SYM_END_DBLOCK
-#                     else
-#                       @in_c_domain_type = false
-#                       yield :END_V_C_DOMAIN_TYPE_BLOCK, :END_V_C_DOMAIN_TYPE_BLOCK
-#                     end
                   else
                     adl_type = @adl_type.pop
@@ -382,4 +377,10 @@
                 @@logger.debug("DADLScanner#scan: Right_bracket_code at #{@filename}:#{@lineno}")
                 yield :Right_bracket_code, :Right_bracket_code
+              when /\A"((?:[^"\\]+|\\.)*)"/ #V_STRING
+                @@logger.debug("DADLScanner#scan: V_STRING, #{$1}")
+                yield :V_STRING, $1
+              when /\A"([^"]*)"/m #V_STRING
+                @@logger.debug("DADLScanner#scan: V_STRING, #{$1}")
+                yield :V_STRING, $1
               when /\A[0-9]{4}-[0-1][0-9]-[0-3][0-9]T[0-2][0-9]:[0-6][0-9]:[0-6][0-9](,[0-9]+)?(Z|[+-][0-9]{4})?|[0-9]{4}-[0-1][0-9]-[0-3][0-9]T[0-2][0-9]:[0-6][0-9](Z|[+-][0-9]{4})?|[0-9]{4}-[0-1][0-9]-[0-3][0-9]T[0-2][0-9](Z|[+-][0-9]{4})?/   #V_ISO8601_EXTENDED_DATE_TIME YYYY-MM-DDThh:mm:ss[,sss][Z|+/- -n-n-n-n-]-
                 @@logger.debug("DADLScanner#scan: V_ISO8601_EXTENDED_DATE_TIME")
@@ -393,10 +394,4 @@
               when /\A[A-Z][a-zA-Z0-9_]*<[a-zA-Z0-9,_<>]+>/   #V_GENERIC_TYPE_IDENTIFIER
                 yield :V_GENERIC_TYPE_IDENTIFIER, $&
-              when /\A"((?:[^"\\]+|\\.)*)"/ #V_STRING
-                @@logger.debug("DADLScanner#scan: V_STRING, #{$1}")
-                yield :V_STRING, $1
-              when /\A"([^"]*)"/m #V_STRING
-                @@logger.debug("DADLScanner#scan: V_STRING, #{$1}")
-                yield :V_STRING, $1
               when /\A[0-9]+\.[0-9]+|[0-9]+\.[0-9]+[eE][+-]?[0-9]+ /   #V_REAL
                 yield :V_REAL, $&
@@ -404,6 +399,4 @@
                 @@logger.debug("DADLScanner#scan: V_INTEGER = #{$&}")
                 yield :V_INTEGER, $&
-              when /\A[a-z]+:\/\/[^<>|\\{}^~"\[\] ]*/ #V_URI
-                yield :V_URI, $&
               when /\A\S/ #UTF8CHAR
                 yield :UTF8CHAR, $&
@@ -601,8 +594,9 @@
               when /\A[hH][hH]:[mM?X][mM?X]:[sS?X][sS?X]/
                 yield :V_ISO8601_TIME_CONSTRAINT_PATTERN, $&
-                #when /\AP([0-9]+[yY])?([0-9]+[mM])?([0-9]+[wW])?([0-9]+[dD])?T([0-9]+[hH])?([0-9]+[mM])?([0-9]+[sS])?|P([0-9]+[yY])?([0-9]+[mM])?([0-9]+[wW])?([0-9]+[dD])?/   #V_ISO8601_DURATION such as PnYnMnWnDTnnHnnMnnS
+#              when /\AP([0-9]+[yY])?([0-9]+[mM])?([0-9]+[wW])?([0-9]+[dD])?T([0-9]+[hH])?([0-9]+[mM])?([0-9]+[sS])?|P([0-9]+[yY])?([0-9]+[mM])?([0-9]+[wW])?([0-9]+[dD])?/   #V_ISO8601_DURATION such as PnYnMnWnDTnnHnnMnnS
+#                yield :V_ISO8601_DURATION, $&
               when /\AP([0-9]+[yY])?([0-9]+[mM])?([0-9]+[wW])?([0-9]+[dD])?T([0-9]+[hH])?([0-9]+[mM])?([0-9]+[sS])?/   #V_ISO8601_DURATION such as PnYnMnWnDTnnHnnMnnS
                 yield :V_ISO8601_DURATION, $&
-              when /\AP[yY]?[mM]?[wW]?[dD]?T[hH]?[mM]?[sS]?/   #V_ISO8601_DURATION_CONSTRAINT_PATTERNo
+              when /\AP[yY]?[mM]?[wW]?[dD]?(T[hH]?[mM]?[sS]?)?/   #V_ISO8601_DURATION_CONSTRAINT_PATTERN
                 yield :V_ISO8601_DURATION_CONSTRAINT_PATTERN, $&
               when /\A[a-z][a-zA-Z0-9_]*/
